import controlP5.*;
ControlP5 cp5;

import ddf.minim.analysis.*;
import ddf.minim.*;
Minim       minim;
AudioPlayer song;
FFT         fft;
AudioInput in;

//Play play;
//Rewind rewind;
//Forward ffwd;

import peasy.*;
PeasyCam camera;

import processing.opengl.*;
import SimpleOpenNI.*;
SimpleOpenNI kinect;

boolean IntriMode;
boolean InputMode;

//background Color
int BGcolor = 0;

//stroke color
int Sr = 255;
int Sg = 255;
int Sb = 255;

int sliderValue = 0;

Slider s;

void setup()
{
  size(1024, 768, OPENGL);

  kinect = new SimpleOpenNI(this);
  kinect.enableDepth();
  camera = new PeasyCam(this, 50);
  //cam.setMinimumDistance(0);
  //cam.setMaximumDistance(1000);

  minim = new Minim(this);



  in = minim.getLineIn();



  // specify that we want the audio buffers of the AudioPlayer
  // to be 1024 samples long because our FFT needs to have 
  // a power-of-two buffer size and this is a good size.

  song = minim.loadFile("Kusanagi.mp3", 1024);

  // buttons for control

//  play = new Play(width/2 - 50, 700, 20, 10);
//  rewind = new Rewind(width/2, 700, 20, 10);
//  ffwd = new Forward(width/2 + 50, 700, 20, 10);

  // loop the file indefinitely

  song.loop();

  // create an FFT object that has a time-domain buffer 
  // the same size as jingle's sample buffer
  // note that this needs to be a power of two 
  // and that it means the size of the spectrum will be half as large.

  fft = new FFT( song.bufferSize(), song.sampleRate() );

  cp5 = new ControlP5(this);

  //add theme switch
  cp5.addButton("THEME")
    .setPosition(100, 200)
      .setSize(200, 19)
        ;
  cp5.setAutoDraw(false);

  //add slider  
  s = cp5.addSlider("sliderValue")
    .setPosition(100, 300)
      .setRange(0, song.length())
        .setSize(500,30)
  ;
}


void draw()
{
  background(BGcolor);
  kinect.update(); 
  
  camera.rotateY(0.01); 
  
  // perform a forward FFT on the samples in jingle's mix buffer,
  // which contains the mix of both the left and right channels of the file
  fft.forward( song.mix );  

  rotateX(radians(180)); // flip y-axis from "realWorld" 
  stroke(Sr, Sg, Sb, 60); 

  // get the depth data as 3D points
  //  PVector[] depthPoints = kinect.depthMapRealWorld(); 

  //  for (int i = 0; i < depthPoints.length; i+=50) {
  //    
  //    // get the current point from the point array
  //    PVector currentPoint = depthPoints[i];
  //    // draw the current point
  //    //translate(0, 0, 0); 
  //    //point(currentPoint.x, currentPoint.y, currentPoint.z);
  //    if(currentPoint.z >400 && currentPoint.z <2000){
  //   
  //   pushMatrix();
  //   translate(currentPoint.x, currentPoint.y, currentPoint.z);
  //   fill(fft.getBand(1),fft.getBand(3),fft.getBand(5),60);
  //   box(fft.getBand(1),fft.getBand(5),fft.getBand(3));
  //   popMatrix();
  //   
  //   pushMatrix();
  //   translate(currentPoint.x +500, currentPoint.y, currentPoint.z);
  //   fill(fft.getBand(1),fft.getBand(3),fft.getBand(5),60);
  //   box(fft.getBand(1),fft.getBand(5),fft.getBand(3));
  //   popMatrix();
  //   }
  //  }
  intriMode();

  if (InputMode)inputMode();  


  hint(DISABLE_DEPTH_TEST);
  camera.beginHUD(); 

  textSize(50);
  if (InputMode)text("INPUT MODE ENABLED", 100, 100);

//  play.update();
//  play.draw();
//  rewind.update();
//  rewind.draw();
//  ffwd.update(); 
//  ffwd.draw();


  cp5.draw();
  camera.endHUD();
  hint(ENABLE_DEPTH_TEST);


  //a spiraling up curve of boxes responding to the music
  for (int j = 0; j < fft.specSize (); j++)
  {
    // draw the line for frequency band j, scaling it up a bit so we can see it
    //line( j, 50, 700, j, 50 - fft.getBand(j)*8, 700 );
    translate(j-50, j, 50);
    fill(255, 255, 255, 60);
    box(fft.getBand(j)*8);
  }

  //  println(sliderValue);
  if (s.isMousePressed()) {
    //    if (mousePressed) {
    song.cue(sliderValue);
    //    }
  }
}


public void controlEvent(ControlEvent theEvent) {
  println(theEvent.getController().getName());
}

public void THEME() {

  println(BGcolor);

  if (BGcolor == 0) {
    BGcolor = 255;

    Sr = 0;
    Sg = 0;
    Sb = 0;
  } else if (BGcolor == 255) {
    BGcolor = 0;

    Sr = 255;
    Sg = 255;
    Sb = 255;
  }
}

void mousePressed()
{
  //  play.mousePressed();
  //  rewind.mousePressed();
  //  ffwd.mousePressed();
}

void mouseReleased()
{
  //  play.mouseReleased();
  //  rewind.mouseReleased();
  //  ffwd.mouseReleased();
}

